module dmamux(
// control
	input [2:0] sel,
	input nen,

// source
	input ndreq0,
	output reg dack0,

	input ndreq1,
	output reg dack1,

	input ndreq2,
	output reg dack2,

	input ndreq3,
	output reg dack3,

	input ndreq4,
	output reg dack4,

// target
	output reg ndreq,
	input dack
);

always @*
begin
if (nen) // disabled
begin
	ndreq <= 'bz;
  dack0 <= 'bz;
  dack1 <= 'bz;
  dack2 <= 'bz;
  dack3 <= 'bz;
  dack4 <= 'bz;
end
else
begin
	case (sel)
	3'h0:
	begin
	ndreq <= ndreq0;
	dack0 <= dack;

	dack1 <= 'bz;
	dack2 <= 'bz;
	dack3 <= 'bz;
	dack4 <= 'bz;
	end
	3'h1:
	begin
	ndreq <= ndreq1;
	dack1 <= dack;

	dack0 <= 'bz;
	dack2 <= 'bz;
	dack3 <= 'bz;
	dack4 <= 'bz;
	end
	3'h2:
	begin
	ndreq <= ndreq2;
	dack2 <= dack;

	dack0 <= 'bz;
	dack1 <= 'bz;
	dack3 <= 'bz;
	dack4 <= 'bz;
	end
	3'h3:
	begin
	ndreq <= ndreq3;
	dack3 <= dack;

	dack0 <= 'bz;
	dack1 <= 'bz;
	dack2 <= 'bz;
	dack4 <= 'bz;
	end
	3'h4:
	begin
	ndreq <= ndreq4;
	dack4 <= dack;

	dack0 <= 'bz;
	dack1 <= 'bz;
	dack2 <= 'bz;
	dack3 <= 'bz;
	end
	default: // disable
	begin
	ndreq <= 'bz;
  dack0 <= 'bz;
  dack1 <= 'bz;
  dack2 <= 'bz;
  dack3 <= 'bz;
  dack4 <= 'bz;
	end
 endcase
end
end


endmodule
